/**********************************************************************
 * This file is part of FMR (Fast Machine Reassignment)               
 *                                                                   
 * ROADEF/EURO Challenge 2012: Machine Reassignment                 
 * http://challenge.roadef.org/2012/en/				   
 * Team S26
 *     
 * Copyright (C) 2011-12 Laboratoire d'Informatique de Paris Nord 
 * UMR CNRS 7030 
 * Institut Galilée - Université Paris-Nord
 * 99, avenue Jean-Baptiste Clément 
 * 93430 Villetaneuse  
 *        
 * FMR is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *  
 * FMR is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with FMR; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 **********************************************************************/
#ifndef fmr_heap
#define fmr_heap 1

#include "fmr.h"

/* Il faudrait vérifier l'utilité d'en stocker autant, a priori 5* c'est pas mal?*/
/* en fait il faudrait différencier Shift et Swap : pas le meme besoin */
#define MAXNBDEPL 5*MAXNBPROCESSUS

/* pour stocker les déplacements dans un tas */
struct deplt {
	unsigned short u1;
	unsigned short u2;
	long gainLoad ;
} deplt;
typedef struct deplt deplt_t;


void free_heap_elts(deplt_t **, unsigned );
void ajoutHeap(unsigned short u1, unsigned short u2, long gain, deplt_t** , unsigned *);
void ajoutHeap2(unsigned short u1, unsigned short u2, long gain, unsigned int indice[], deplt_t t[], unsigned *nbElt) ;
void oteHeap (deplt_t** , unsigned *);
void afficheHeap( deplt_t** , unsigned ) ;
void oteHeap2 (unsigned indice[], deplt_t t[], unsigned *nbElt) ;

#endif
